# coding: utf-8

# flake8: noqa
"""
    University Human Resources API

    This API exposes identity information from the University Human Resources system. The purpose of this API is to give access to basic identity information about staff members for use by downstream systems, therefore the data exposed is limited to basic information about who a staff member is and details of any affiliations they have.  This API uses the following identifiers to link people to person-records held within different systems:  * `person.v1.human-resources.university.identifiers.cam.ac.uk` - the university human resources (uhr) identifier of     this person - also known as the staff number of HRN. * `v1.person.identifiers.cam.ac.uk` - the common registration scheme identifier (CRSid) of     this person.  Additionally this API uses the following identifiers to link people to institutions or entities which a person may have an affiliation to:  * `institution.v1.human-resources.university.identifiers.cam.ac.uk` - the university human resources (uhr) institution     identifier. This encompasses departments within the University HR system     (currently CHRIS). * `institution.v1.student-records.university.identifiers.cam.ac.uk` - the student records institution identifier. This     encompasses colleges within the University Student Records system (currently CamSIS).  Affiliations can be used to indicate an institution that a person holds a position within, with the `status` indicating the job role that is held and the scheme of the affiliation being `institution.v1.human-resources.university.identifiers.cam.ac.uk`. Additionally an affiliation can indicate a staff member's line manager with the scheme being `person.v1.human-resources.university.identifiers.cam.ac.uk` and the status being `report`. A staff member can have multiple institution affiliations and multiple report affiliations.  This API is currently backed by data from CHRIS, exposing a view which is updated hourly.  

    The version of the OpenAPI document: v1alpha2
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


# import models into model package
from identitylib.hr_client.models.affiliation import Affiliation
from identitylib.hr_client.models.affiliation_scheme import AffiliationScheme
from identitylib.hr_client.models.http_exception import HTTPException
from identitylib.hr_client.models.http_validation_error import HTTPValidationError
from identitylib.hr_client.models.identifier import Identifier
from identitylib.hr_client.models.identifier_scheme import IdentifierScheme
from identitylib.hr_client.models.location_inner import LocationInner
from identitylib.hr_client.models.paginated_results_staff_member import PaginatedResultsStaffMember
from identitylib.hr_client.models.staff_member import StaffMember
from identitylib.hr_client.models.validation_error import ValidationError
